<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_password_change extends cmsPlugin {

    public $config = array (
        'period'    => 120
    );

    public function __construct(){

        $this->info = array(
            'plugin'      => 'p_password_change',
            'title'       => 'Напоминание о смене пароля',
            'description' => 'Периодически информирует пользователя о необходимости смены пароля',
            'author'      => '<a href="http://www.instantvideo.ru/" target="_blank">InstantMedia team</a>',
            'version'     => '1.1',
            'published'   => 1
        );

        $this->events = array(
            'USER_LOGIN',
            'UPDATE_USER_PASSWORD'
        );

        parent::__construct();

    }

    public function install(){

        parent::install();

        if (!$this->inDB->isFieldExists('cms_users', 'password_change_date')){

            $this->inDB->query("ALTER TABLE `cms_users` ADD `password_change_date` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP AFTER `invdate`");
            $this->inDB->query("UPDATE `cms_users` SET `password_change_date` = `regdate`");

        }

        return true;

    }


    /**
     * Обработка событий
     * @param string $event
     * @param mixed $user
     * @return html
     */
    public function execute($event, $user){

        global $_LANG;

        switch ($event){
            case 'USER_LOGIN':

                $diff_days = $this->config['period'] - round((time() - strtotime($user['password_change_date']))/86400);

                if($diff_days <= 0){
                    cmsCore::addSessionMessage($_LANG['P_PASSWORD_CHANGE_TEXT'], 'info');
                }

                break;
            case 'UPDATE_USER_PASSWORD':

                // Если пароль сменили на такой же, который был, не разрешаем это
                if($user['oldpass'] == $user['newpass']){
                    cmsCore::addSessionMessage($_LANG['P_PASSWORD_CHANGE_PASS_TEXT'], 'error');
                    cmsCore::redirect('/'.cmsUser::PROFILE_LINK_PREFIX.$user['user_id'].'/editprofile.html');
                }

                $this->inDB->query("UPDATE cms_users SET password_change_date = NOW() WHERE id = '{$user['user_id']}'");

                break;
        }

        return $user;

    }

}
